//
//  CircleProgessView.m
//  Gmcchh
//
//  Created by on 14-3-4.
//  Copyright (c) 2014年 All rights reserved.
//

#import "CircleProgessView.h"

@interface CircleProgessView () {
    CGFloat progress;
}
@end;

@implementation CircleProgessView

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [UIColor clearColor];
        progress = 0;
    }
    return self;
}

- (void)drawRect:(CGRect)rect
{
    if (progress>1) {
        progress=1;
    }
    if (progress<0) {
        progress=0;
    }
    CGContextRef context = UIGraphicsGetCurrentContext();
    
    CGContextSetLineWidth(context, 1);
    CGContextSetLineCap(context, kCGLineCapRound);
    CGContextSetStrokeColorWithColor(context, [UIColor blueColor].CGColor);
    CGFloat startAngle = 0;
    CGFloat step = 11.4*M_PI/6 * progress;//弧线对应的角度
    CGContextAddArc(context, self.bounds.size.width/2, self.bounds.size.height/2, self.bounds.size.width/2-1, startAngle, startAngle+step, 0);
    //CGContextAddArc 画一曲线 前两点为中心 中间两点为起始弧度 最后那个参数为0则顺时针画 1则逆时针
    
    CGContextStrokePath(context);
}

-(void)drawCircleWithProgress:(CGFloat)mProgress{
    progress = mProgress;
    [self setNeedsDisplay];//这个方法会调用drawRect:方法
}

-(void)startAnimation{
    [self drawCircleWithProgress:1];
    
    //绕z轴旋转
    CABasicAnimation* rotate =  [CABasicAnimation animationWithKeyPath: @"transform.rotation.z"];
    rotate.removedOnCompletion = FALSE;
    rotate.fillMode = kCAFillModeForwards;
    [rotate setToValue: [NSNumber numberWithFloat: M_PI / 2]];
    rotate.repeatCount = HUGE_VALF;
    
    rotate.duration = 0.25;
    rotate.cumulative = TRUE;
    
    //控制动画速度
    rotate.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionLinear];
    //kCAMediaTimingFunctionLinear 线性（匀速）|
    //kCAMediaTimingFunctionEaseIn 先慢|
    //kCAMediaTimingFunctionEaseOut 后慢|
    //kCAMediaTimingFunctionEaseInEaseOut 先慢 后慢 中间快|
    //kCAMediaTimingFunctionDefault 默认|
    
    [self.layer addAnimation:rotate forKey:@"rotateAnimation"];
}

-(void)stopAnimation{
    [self.layer removeAnimationForKey:@"rotateAnimation"];
}

@end
