//
//  GMActivityView.m
//  Gmcchh
//
//  Created by on 14-5-8.
//  Copyright (c) 2014年 All rights reserved.
//

#import "GMActivityView.h"
#define FRONT_IMAGE @"bg_ActivityView_normal"
#define BACK_IMAGE  @"bg_ActivityView_hight"
#define SPEED_TIME 1.2
#define SPEED_DELAY 0.05

@interface GMActivityView ()
@property (nonatomic,strong)UIView *frontView;
@property (nonatomic,strong)UIView *backView;
@property (nonatomic,assign)BOOL   isStop;
@end

@implementation GMActivityView

- (id)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        [self configSubViews];
    }
    return self;
}

- (void)configSubViews {
    //用一张白色的图片先挡在蓝色图片上面
    self.frontView=[[UIView alloc] initWithFrame:self.bounds];
    UIImageView *fImage=[[UIImageView alloc] initWithFrame:self.frontView.bounds];;
    fImage.image=[UIImage imageNamed:FRONT_IMAGE];
    [self.frontView addSubview:fImage];
    self.frontView.backgroundColor=[UIColor clearColor];
    self.frontView.clipsToBounds=YES;
    
    //蓝色图片放后面
    self.backView=[[UIView alloc] initWithFrame:self.bounds];
    UIImageView *bImage=[[UIImageView alloc] initWithFrame:self.backView.bounds];;
    bImage.image=[UIImage imageNamed:BACK_IMAGE];
    [self.backView addSubview:bImage];
    self.backView.backgroundColor=[UIColor clearColor];
    self.backView.clipsToBounds=YES;
    
    [self addSubview:self.backView];
    [self addSubview:self.frontView];
}

//这个方法指定的是白色图片的高度：当!isFull的时候，白色图片完全显示，蓝色图片看不见；当isFull的时候，白色图片不见，蓝色图片完全显示。
- (void)setIsFull:(BOOL)isFull {
    _isFull = isFull;
    if (!isFull) {
        self.frontView.frame = self.bounds;
    }else {
        CGRect rect = self.bounds;
        rect.size.height = 0;
        self.frontView.frame = rect;
    }
}

- (void)startAnimation {
    __weak GMActivityView *weakSelf = self;
    self.hidden = NO;
    self.isFull = NO;
    self.isStop = NO;
    CGRect rect = self.bounds;
    rect.size.height = 0;
    
    [UIView animateWithDuration:SPEED_TIME delay:SPEED_DELAY options:UIViewAnimationOptionCurveLinear animations:^{
        //frontView白色图片从完全显示变化到高度为0，出现了蓝色图片高度增加的效果
        weakSelf.frontView.frame = rect;
    } completion:^(BOOL finished) {
        if (weakSelf.isStop) {
            return;
        }
        //不断循环
        [weakSelf startAnimation];
    }];
}

- (void)drawViewWithProgress:(CGFloat)progress{
    if (progress>1) {
        progress=1;
    }
    if (progress<0) {
        progress=0;
    }
    
    CGRect frontViewFrame = self.frontView.frame;
    CGFloat frontViewHeight = self.frame.size.height*(1-progress);
    [self.frontView setFrame:CGRectMake(frontViewFrame.origin.x, frontViewFrame.origin.y, frontViewFrame.size.width, frontViewHeight)];
}

- (void)stopAnimation {
    self.isStop = YES;
    self.isFull = YES;
    if (self.hidesWhenStopped) {
        self.hidden = YES;
    }
}

@end
