//
//  ViewController.m
//  TestPullToRefresh
//
//  Created by 杨淳引 on 15/7/31.
//  Copyright (c) 2015年 杨淳引. All rights reserved.
//

#import "ViewController.h"
#import "GMPullToAction.h"

#define RGB(r, g, b)             [UIColor colorWithRed:((r) / 255.0) green:((g) / 255.0) blue:((b) / 255.0) alpha:1.0]

@interface ViewController () <UIScrollViewDelegate>
@property (nonatomic, strong)UIScrollView *scrollView;
@property (nonatomic, strong)UILabel *num;
@property (nonatomic, assign)int counter;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self configTestInfo];
}

- (void)configTestInfo {
    UIView *fakeNavBar = [[UIView alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 58)];
    fakeNavBar.backgroundColor = RGB(95, 230, 226);
    [self.view addSubview:fakeNavBar];
    
    self.scrollView = [[UIScrollView alloc]initWithFrame:CGRectMake(0, 58, self.view.bounds.size.width, self.view.bounds.size.height-58)];
    self.scrollView.backgroundColor = [UIColor whiteColor];
    self.scrollView.contentSize = CGSizeMake(self.view.frame.size.width, self.view.frame.size.height);
    self.scrollView.delegate = self;
    [self.view addSubview:self.scrollView];
    
    UIView *labelView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, 400)];
    labelView.backgroundColor = RGB(237, 252, 214);
    [self.scrollView addSubview:labelView];
    
    self.num = [[UILabel alloc]init];
    self.num.font = [UIFont systemFontOfSize:30];
    self.num.textColor = RGB(112, 231, 70);
    self.num.text = [NSString stringWithFormat:@"%d", self.counter];
    [self.num sizeToFit];
    [self.num setCenter:CGPointMake(labelView.center.x, 50)];
    [labelView addSubview:self.num];
    
    __weak ViewController *weakSelf = self;
    [self.scrollView addPullToRefreshWithActionHandler:^{
        NSThread *new = [[NSThread alloc]initWithTarget:weakSelf selector:@selector(stop) object:nil];
        [new start];
    }];
}

- (void)stop {
    [NSThread sleepForTimeInterval:3.f];
    self.counter++;
    self.num.text = [NSString stringWithFormat:@"%d", self.counter];
    [self stopAnimation];
}

//必须实现这个协议方法，才会在拖动的时候产生动画效果
- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    if (scrollView == self.scrollView) {
        [scrollView didScroll];
    }
}

- (void)stopAnimation {
    //必须通过这个方法来停止动画
    [self.scrollView.pullToRefreshView stopAnimating];
}

@end
